#import "GLAtlantis.h"
#import "atlantis.h"

int NRAND_ATL (int foo) {

    NSNumber *intValue = [NSNumber numberWithInt:(foo - 1)];

    float randValue = SSRandomFloatBetween(1.0, [intValue floatValue]);
    return [[NSNumber numberWithFloat:randValue] intValue];
}

@implementation GLAtlantis	

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    self = [super initWithFrame:frameRect isPreview:preview];
    
    as = (atlantisstruct *) malloc(sizeof (atlantisstruct));
    
    	as->num_sharks = SSRandomInt() % 10;
	as->sharkspeed = 100; //MI_CYCLES(mi);		/* has influence on the "width" of the movement */
	as->sharksize = 6000; // MI_SIZE(mi);	/* has influence on the "distance" of the sharks */
	as->whalespeed = 250;
	as->wire = 0; //MI_IS_WIREFRAME(mi);

        
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }

    return self;
}


- (void)dealloc
{
    if (as->sharks)
            (void) free((void *) as->sharks);

    free(as);
    [_view removeFromSuperview];
    [super dealloc];
}



- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}

- (void)stopAnimation
{
    _initedGL = NO;
    [super stopAnimation];

    return;
}


- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        Reshape(as, (int)[self frame].size.width, (int)[self frame].size.height);
        Init(as);
        _initedGL = YES;
    }

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glPushMatrix();

    AllDisplay(as);
    Animate(as);
    glFlush();
    
    return;
}


- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { 
    return nil; 
}

@end