#import "Gears.h"

#import "gears.c"

#include <OpenGL/CGLContext.h>

@implementation Gears	

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    gs = (gearsstruct *)malloc(sizeof(gearsstruct));
    
    self = [super initWithFrame:frameRect isPreview:preview];
            
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		//NSOpenGLPFAMinimumPolicy,
		//NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }
    
    return self;
}

- (void)dealloc
{
    if (glIsList(gs->gear1))
            glDeleteLists(gs->gear1, 1);
    if (glIsList(gs->gear2))
            glDeleteLists(gs->gear2, 1);
    if (glIsList(gs->gear3))
            glDeleteLists(gs->gear3, 1);
    free(gs);
    [_view removeFromSuperview];
    [super dealloc];
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}

- (void)stopAnimation
{
    _initedGL = NO;
    [super stopAnimation];

    return;
}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
    	gs->view_rotx = SSRandomFloatBetween(0,360);
	gs->view_roty = SSRandomFloatBetween(0,360);
	gs->view_rotz = SSRandomFloatBetween(0,360);
	gs->angle = SSRandomFloatBetween(0,360);
        reshape([self frame].size.width, [self frame].size.height);

        pinit(gs);
        _initedGL = YES;
    } else {
        draw_gears(gs);
    }

    return;
}


- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { return nil; }

@end
