#import "MoreGears.h"

#import "gears2.c"

@implementation MoreGears	

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{    
    self = [super initWithFrame:frameRect isPreview:preview];
        
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }
    
    return self;
}

- (void)dealloc
{
    [_view removeFromSuperview];
    [super dealloc];
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        reshape([self frame].size.width, [self frame].size.height);

        init_gears();
        _initedGL = YES;
    }
    draw_gears();
    oneFrame();
    glFlush();
    
    return;
}


- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { return nil; }

@end
