#import "GLPlane.h"

#import "OpenGLplane.c"

@implementation GLPlane	

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    planes = (local_planes *)malloc(sizeof(local_planes));
    
    self = [super initWithFrame:frameRect isPreview:preview];
        
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }
    
    return self;
}

- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;
}

- (void)dealloc
{
    free(planes);
    [_view removeFromSuperview];
    [super dealloc];
}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        init_plane(*planes);
        draw_plane(*planes);

        _initedGL = YES;
    }
    animate_plane(*planes);
    
    return;
}


- (BOOL)hasConfigureSheet { return NO; }
- (NSWindow*)configureSheet { return nil; }

@end
