#import "GLPipes.h"
#import "pipes.c"



// defined by FreeSpace
float randBetween(float a, float b);

int NRAND_PIPES (int foo) {

    NSNumber *intValue = [NSNumber numberWithInt:(foo - 1)];

    float randValue = SSRandomFloatBetween(1.0, [intValue floatValue]);
    return [[NSNumber numberWithFloat:randValue] intValue];
}

@implementation GLPipes	

- (id)initWithFrame:(NSRect)frameRect isPreview:(BOOL)preview
{
    BOOL foo;
    self = [super initWithFrame:frameRect isPreview:preview];
    
    pp = (pipesstruct *) malloc(sizeof (pipesstruct));
    
    pp->isMono = 0;
    pp->isWireframe = 0;
    
    if (self) {
	NSOpenGLPixelFormatAttribute attribs[] =
        {	NSOpenGLPFAAccelerated,
		NSOpenGLPFADepthSize, 16,
		NSOpenGLPFAMinimumPolicy,
		NSOpenGLPFAClosestPolicy,
                0
        };
	
	NSOpenGLPixelFormat *format = [[[NSOpenGLPixelFormat alloc] initWithAttributes:attribs] autorelease];
		
        _view = [[[NSOpenGLView alloc] initWithFrame:NSZeroRect pixelFormat:format] autorelease];
        [self addSubview:_view];
    }

    factory = [(NSNumber *)CFPreferencesCopyAppValue(@"GLPipesDefine", @"EPScreenSavers") intValue];
    fisheye = [(NSNumber *)CFPreferencesCopyAppValue(@"GLPipesCloseUp", @"EPScreenSavers") intValue];
    tightturns = [(NSNumber *)CFPreferencesCopyAppValue(@"GLPipesTurns", @"EPScreenSavers") intValue];
    rotatepipes = [(NSNumber *)CFPreferencesCopyAppValue(@"GLPipesRotate", @"EPScreenSavers") intValue];
    
    return self;
}


- (void)dealloc
{
    free(pp);
    [_view removeFromSuperview];
    [super dealloc];
}



- (void)setFrameSize:(NSSize)newSize
{
    [super setFrameSize:newSize];
    [_view setFrameSize:newSize];
    _initedGL = NO;

}

- (void)animateOneFrame
{
    [[_view openGLContext] makeCurrentContext];
    if (!_initedGL) {
        init_pipes(pp);
        reshape_pipes(pp, (int)[self frame].size.width, (int)[self frame].size.height);

        _initedGL = YES;
    }
    draw_pipes(pp);
    
    return;
}


- (void)stopAnimation
{
    _initedGL = NO;
    [super stopAnimation];

    return;
}

- (BOOL)hasConfigureSheet { return YES; }
- (NSWindow*)configureSheet { 

    [NSBundle loadNibNamed:@"GLPipes.nib" owner:self];
    [defineLevel setIntValue:factory];
    [closeUp setState:fisheye];
    [tightTurns setState:tightturns];
    [rotatePipes setState:rotatepipes];
    return window; 
}

- (void)closeSheet:(id)sender
{
    [NSApp endSheet:window];
}

- (void)updateSelections:sender
{   	
    factory = [defineLevel intValue];
    fisheye = [closeUp state];
    tightturns = [tightTurns state];
    rotatepipes = [rotatePipes state];

    CFPreferencesSetAppValue(@"GLPipesDefine",[NSNumber numberWithInt:factory], @"EPScreenSavers");
    CFPreferencesSetAppValue(@"GLPipesCloseUp",[NSNumber numberWithInt:fisheye], @"EPScreenSavers");
    CFPreferencesSetAppValue(@"GLPipesTurns",[NSNumber numberWithInt:tightturns], @"EPScreenSavers");
    CFPreferencesSetAppValue(@"GLPipesRotate",[NSNumber numberWithInt:rotatepipes], @"EPScreenSavers");
    
    CFPreferencesAppSynchronize(@"EPScreenSavers");
    
    init_pipes(pp);
}

@end